"use strict";

var express = require('express');

var router = express.Router();

var HPMConfig = require('../service/hpmConfig');

var hpmConfig = new HPMConfig();
router.get('/', function (req, res, next) {
  try {
    var config = hpmConfig.getConfig();
    Object.keys(config).forEach(function (key) {
      if (config[key] === 'false') {
        config[key] = false;
      }

      if (config[key] === 'true') {
        config[key] = true;
      }
    });
    var result = {
      code: 200,
      data: config,
      message: 'success'
    };
    res.send(result);
  } catch (err) {
    next(err);
  }
});
router.post('/', function (req, res, next) {
  try {
    var config = req.body;
    hpmConfig.setConfig(config);
    res.send({
      code: 200,
      message: 'success'
    });
  } catch (err) {
    next(err);
  }
});
router.delete('/', function (req, res, next) {
  try {
    var configkeys = req.body;
    hpmConfig.deleteConfig(configkeys);
    res.send({
      code: 200,
      message: 'success'
    });
  } catch (err) {
    next(err);
  }
});
module.exports = router;