"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var router = express.Router();

var PluginManager = require('../service/plugin-manager');

var appEvent = require('../event');

var registerPluginRouter = require('../pluginRouter');

router.get('/', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var result, pluginManager, disabledPlugins, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            result = {
              code: 200,
              message: 'success'
            };
            _context.next = 4;
            return new PluginManager();

          case 4:
            pluginManager = _context.sent;
            disabledPlugins = PluginManager.getDisabledPlugins();
            data = pluginManager.plugins.map(function (plugin) {
              plugin.isDisabled = disabledPlugins.includes(plugin.name);
              return plugin;
            });
            result.data = data;
            res.send(result);
            _context.next = 14;
            break;

          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 11]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
router.get('/disabled', function (req, res, next) {
  try {
    var result = {
      code: 200,
      message: 'success'
    };
    var data = PluginManager.getDisabledPlugins();
    result.data = data;
    res.send(result);
  } catch (err) {
    next(err);
  }
});
router.post('/disabled', function (req, res, next) {
  try {
    var name = req.body.name;
    var result = {
      code: 200,
      message: 'success'
    };
    PluginManager.addDisabledPlugin(name);
    appEvent.emit('routerUninstall', {
      _routeId: name
    });
    registerPluginRouter();
    res.send(result);
  } catch (err) {
    next(err);
  }
});
router.delete('/disabled', function (req, res, next) {
  try {
    var name = req.body.name;
    var result = {
      code: 200,
      message: 'success'
    };
    PluginManager.removeDisabledPlugin(name);
    registerPluginRouter();
    res.send(result);
  } catch (err) {
    next(err);
  }
});
module.exports = router;