"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var fs = require('fs');

var path = require('path');

var router = express.Router();

var appEvent = require('../event');

var project = require('../service/project');

var taskService = require('../service/task-service');

var _require = require('../utils/utils'),
    setGlobalItem = _require.setGlobalItem,
    getGlobalItem = _require.getGlobalItem;

var HPM_API = getGlobalItem('api');
router.get('/bundle', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var result, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            result = {
              code: 200,
              message: 'success'
            };
            _context.next = 4;
            return project.getBundleJSON();

          case 4:
            data = _context.sent;
            result.data = data;
            res.send(result);
            _context.next = 12;
            break;

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 9]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
router.get('/file', /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res, next) {
    var filename, result, data;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            filename = req.query.filename;
            result = {
              code: 200,
              message: 'success'
            };
            _context2.next = 5;
            return project.getTextFile(filename);

          case 5:
            data = _context2.sent;
            result.data = data;
            res.send(result);
            _context2.next = 13;
            break;

          case 10:
            _context2.prev = 10;
            _context2.t0 = _context2["catch"](0);
            next(_context2.t0);

          case 13:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[0, 10]]);
  }));

  return function (_x4, _x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}());
router.post('/bundle', /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(req, res, next) {
    var _req$body, _req$body$bundleJson, bundleJson, _req$body$bundlePath, bundlePath, template, saveBundleJson, bundleJsonPath, result, isExistsBundle, oldBundleJson, cwd, routePath, staticPath;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            _req$body = req.body, _req$body$bundleJson = _req$body.bundleJson, bundleJson = _req$body$bundleJson === void 0 ? {} : _req$body$bundleJson, _req$body$bundlePath = _req$body.bundlePath, bundlePath = _req$body$bundlePath === void 0 ? process.cwd() : _req$body$bundlePath, template = _req$body.template;
            saveBundleJson = bundleJson;
            bundleJsonPath = path.join(bundlePath, bundlePath.endsWith('bundle.json') ? '' : 'bundle.json');
            result = {
              code: 200,
              message: 'success'
            };
            isExistsBundle = fs.existsSync(bundleJsonPath);

            if (!(template && !isExistsBundle)) {
              _context3.next = 9;
              break;
            }

            _context3.next = 9;
            return HPM_API.init({
              name: bundleJson.name,
              template: template,
              dirname: bundlePath
            });

          case 9:
            if (isExistsBundle) {
              oldBundleJson = JSON.parse(fs.readFileSync(bundleJsonPath).toString());
              saveBundleJson = _objectSpread(_objectSpread({}, oldBundleJson), saveBundleJson);
            }

            HPM_API.save(saveBundleJson, bundlePath);

            if (bundlePath !== process.cwd) {
              process.chdir(bundlePath);
              cwd = process.cwd();
              setGlobalItem('cwd', cwd);
              taskService.init();
            }

            routePath = '/api/resource';
            staticPath = path.join(process.cwd(), 'ohos_bundles', '.output');
            appEvent.emit('assetAdd', {
              routePath: routePath,
              staticPath: staticPath,
              id: 'output'
            });
            HPM_API.setRecentProject(bundleJson.name, bundlePath);
            res.send(result);
            _context3.next = 22;
            break;

          case 19:
            _context3.prev = 19;
            _context3.t0 = _context3["catch"](0);
            next(_context3.t0);

          case 22:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[0, 19]]);
  }));

  return function (_x7, _x8, _x9) {
    return _ref3.apply(this, arguments);
  };
}());
module.exports = router;