"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var router = express.Router();

var shell = require('shelljs');

var fs = require('fs');

var path = require('path');

var _require = require('../utils/utils'),
    getGlobalItem = _require.getGlobalItem;

var HPM_API = getGlobalItem('api');
router.get('/list', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var name, result, manifest, readmes, files, _yield$HPM_API$getRem, _yield$HPM_API$getRem2, data, index, readme, content;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            name = req.query.name;
            result = {
              code: 200,
              message: 'success'
            };
            manifest = HPM_API.getLocalBundle(name);
            readmes = [];

            if (!manifest) {
              _context.next = 12;
              break;
            }

            files = shell.ls(manifest.path);
            readmes = files.filter(function (file) {
              return ['README.md', 'README_EN.md', 'README_CN.md'].includes(file);
            });
            readmes = readmes.map(function (readme) {
              var item = {};

              switch (readme) {
                case 'README.md':
                  {
                    item.language = 'default';
                    item.path = path.join(manifest.path, 'README.md');
                    item.content = fs.readFileSync(item.path).toString();
                    break;
                  }

                case 'README_EN.md':
                  {
                    item.language = 'en';
                    item.path = path.join(manifest.path, 'README_EN.md');
                    item.content = fs.readFileSync(item.path).toString();
                    break;
                  }

                case 'README_CN.md':
                  {
                    item.language = 'cn';
                    item.path = path.join(manifest.path, 'README_CN.md');
                    item.content = fs.readFileSync(item.path).toString();
                    break;
                  }

                default:
                  break;
              }

              return item;
            });
            result.data = readmes;
            _context.next = 29;
            break;

          case 12:
            _context.next = 14;
            return HPM_API.getRemoteBundleDetails(name);

          case 14:
            _yield$HPM_API$getRem = _context.sent;
            _yield$HPM_API$getRem2 = _yield$HPM_API$getRem.data;
            data = _yield$HPM_API$getRem2 === void 0 ? [] : _yield$HPM_API$getRem2;

            if (!(data && data.length > 0)) {
              _context.next = 29;
              break;
            }

            readmes = data[0].readmes;
            index = 0;

          case 20:
            if (!(index < readmes.length)) {
              _context.next = 29;
              break;
            }

            readme = readmes[index];
            _context.next = 24;
            return HPM_API.getRemoteReadme(readme.url);

          case 24:
            content = _context.sent;
            readme.content = content;

          case 26:
            index++;
            _context.next = 20;
            break;

          case 29:
            result.data = readmes;
            res.send(result);
            _context.next = 36;
            break;

          case 33:
            _context.prev = 33;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 36:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 33]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
module.exports = router;