"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var router = express.Router();

var Template = require('../service/template');

var template = new Template();
router.get('/', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var searchKey, result, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            searchKey = req.query.searchKey;
            result = {
              code: 200,
              message: 'success'
            };
            data = [];

            if (!searchKey) {
              _context.next = 10;
              break;
            }

            _context.next = 7;
            return template.getRemoteTemplates();

          case 7:
            data = _context.sent;
            _context.next = 11;
            break;

          case 10:
            data = template.getTemplates();

          case 11:
            result.data = data;
            res.send(result);
            _context.next = 18;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 18:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 15]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
router.get('/remote', /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res, next) {
    var _req$query, searchKey, curPage, pageSize, version, result, _yield$template$getRe, data, error;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _req$query = req.query, searchKey = _req$query.searchKey, curPage = _req$query.curPage, pageSize = _req$query.pageSize, version = _req$query.version;
            result = {
              code: 200,
              message: 'success'
            };
            _context2.next = 5;
            return template.getRemoteTemplates({
              searchKey: searchKey,
              curPage: curPage,
              pageSize: pageSize,
              ver: version
            });

          case 5:
            _yield$template$getRe = _context2.sent;
            data = _yield$template$getRe.data.data;
            result.data = data;
            res.send(result);
            _context2.next = 15;
            break;

          case 11:
            _context2.prev = 11;
            _context2.t0 = _context2["catch"](0);
            error = {
              code: 500,
              message: _context2.t0.message || _context2.t0
            };
            res.send(error);

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[0, 11]]);
  }));

  return function (_x4, _x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}());
module.exports = router;