"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var fs = require('fs');

var path = require('path');

var router = express.Router();

var shell = require('shelljs');

var project = require('../service/project');

var taskService = require('../service/task-service');

var appEvent = require('../event');

var _require = require('../utils/utils'),
    setGlobalItem = _require.setGlobalItem,
    localOpen = _require.openBrowser,
    getGlobalItem = _require.getGlobalItem;

var HPM_API = getGlobalItem('api');
router.get('/cwd', function (req, res, next) {
  try {
    var cwd = process.cwd();
    var result = {
      code: 200,
      data: {
        currentPath: cwd,
        isBundle: fs.existsSync(path.join(cwd, 'bundle.json'))
      }
    };
    res.send(result);
  } catch (err) {
    next(err);
  }
});
router.get('/ls', function (req, res, next) {
  try {
    var target = req.query.target;

    if (!target) {
      target = process.cwd(); // throw new Error('target is required !')
    }

    var targetPath = target.endsWith(':') ? target + '/' : target;
    var targetStats = fs.statSync(targetPath);

    if (targetStats.isDirectory()) {
      var data = fs.readdirSync(targetPath, {
        withFileTypes: true
      });
      var result = {
        code: 200,
        data: data.map(function (file) {
          return {
            name: file.name,
            isDirectory: file.isDirectory()
          };
        })
      };
      res.send(result);
    } else {
      throw new Error("".concat(target, " is not a directory"));
    }
  } catch (err) {
    next(err);
  }
});
router.get('/upper', function (req, res, next) {
  try {
    var data = shell.ls('..');
    res.send({
      code: 200,
      data: data
    });
  } catch (err) {
    next(err);
  }
});
router.post('/open', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var _req$body$target, target, projectPath, pre, cwd, bundle, routePath, staticPath;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _req$body$target = req.body.target, target = _req$body$target === void 0 ? '' : _req$body$target;
            projectPath = target;

            if (target) {
              _context.next = 6;
              break;
            }

            res.send({
              code: 400,
              message: '"target" is required'
            });
            return _context.abrupt("return");

          case 6:
            if (!(typeof target !== 'string')) {
              _context.next = 9;
              break;
            }

            res.send({
              code: 400,
              message: '"target" should be a string'
            });
            return _context.abrupt("return");

          case 9:
            if (target.endsWith('bundle.json')) {
              projectPath = target.substring(0, target.length - 'bundle.json'.length - 1);
            }

            if (fs.existsSync(path.join(projectPath, 'bundle.json'))) {
              _context.next = 13;
              break;
            }

            res.send({
              code: 400,
              message: "Can not found \"bundle.json\" in ".concat(projectPath)
            });
            return _context.abrupt("return");

          case 13:
            pre = process.cwd();
            process.chdir(projectPath);
            cwd = process.cwd();
            setGlobalItem('cwd', cwd);
            _context.next = 19;
            return project.getBundleJSON();

          case 19:
            bundle = _context.sent;
            routePath = '/api/resource';
            staticPath = path.join(cwd, 'ohos_bundles', '.output');
            appEvent.emit('assetAdd', {
              routePath: routePath,
              staticPath: staticPath,
              id: 'output'
            });
            HPM_API.setRecentProject(bundle.name, cwd);

            if (pre !== cwd) {
              taskService.init();
            }

            res.send({
              code: 200,
              data: cwd,
              message: 'success'
            });
            _context.next = 31;
            break;

          case 28:
            _context.prev = 28;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 31:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 28]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
router.post('/local/open', /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res, next) {
    var _req$body$target2, target;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            try {
              _req$body$target2 = req.body.target, target = _req$body$target2 === void 0 ? '' : _req$body$target2;

              if (!target) {
                res.send({
                  code: 400,
                  message: '"target" is required'
                });
              }

              if (typeof target !== 'string') {
                res.send({
                  code: 400,
                  message: '"target" should be a string'
                });
              }

              if (!fs.existsSync(target)) {
                res.send({
                  code: 400,
                  message: 'Can not found "projectPath"'
                });
              }

              localOpen(target);
              res.send({
                code: 200,
                message: 'success'
              });
            } catch (err) {
              next(err);
            }

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x4, _x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}());
router.get('/recent', function (req, res, next) {
  try {
    var data = HPM_API.getRecentProject();
    res.send({
      code: 200,
      data: data
    });
  } catch (err) {
    next(err);
  }
});
router.delete('/recent', function (req, res, next) {
  try {
    var _req$body = req.body,
        name = _req$body.name,
        _path = _req$body.path;
    var isDelete = true;
    HPM_API.setRecentProject(name, _path, isDelete);
    res.send({
      code: 200,
      message: 'success'
    });
  } catch (err) {
    next(err);
  }
});
module.exports = router;