"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var fs = require('fs');

var os = require('os');

var ApiHandler = require('../utils/apiHandler');

var path = require('path');

var appEvent = require('../event');

var _require = require('../utils/utils'),
    getGlobalItem = _require.getGlobalItem,
    mkMoreDir = _require.mkMoreDir,
    writeFile = _require.writeFile;

var _require2 = require('../utils/constant'),
    fileMap = _require2.fileMap;

var project = require('../service/project');

var ProductLine = /*#__PURE__*/function (_ApiHandler) {
  _inherits(ProductLine, _ApiHandler);

  var _super = _createSuper(ProductLine);

  function ProductLine() {
    var _this;

    _classCallCheck(this, ProductLine);

    _this = _super.call(this);
    _this.packageFolderPath = path.resolve(os.homedir(), '.hpm', 'dataPackages');
    setTimeout(function () {
      _this.assetDatapackages();
    }, 0);
    return _this;
  }

  _createClass(ProductLine, [{
    key: "applyComponents",
    value: function () {
      var _applyComponents = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(body) {
        var bundlePath, data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                bundlePath = path.join(getGlobalItem('cwd'), 'bundle.json');

                if (fs.existsSync(bundlePath)) {
                  _context.next = 3;
                  break;
                }

                throw new Error("Can not found \"bundle.json\" in ".concat(__filename));

              case 3:
                _context.next = 5;
                return project.getBundleJSON();

              case 5:
                data = _context.sent;
                data.dependencies = body;
                _context.next = 9;
                return writeFile(bundlePath, JSON.stringify(data, null, 4));

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function applyComponents(_x) {
        return _applyComponents.apply(this, arguments);
      }

      return applyComponents;
    }()
  }, {
    key: "assetDatapackages",
    value: function assetDatapackages() {
      if (!fs.existsSync(this.packageFolderPath)) {
        fs.mkdirSync(this.packageFolderPath);
      }

      var routePath = '/api/datapackages';
      var staticPath = this.packageFolderPath;
      appEvent.emit('assetAdd', {
        routePath: routePath,
        staticPath: staticPath,
        id: 'datapackages'
      });
    }
  }, {
    key: "isCached",
    value: function isCached(productionLineId, productionVersion) {
      var packagePath = path.resolve(this.packageFolderPath, productionLineId, productionVersion);
      return fs.existsSync(packagePath) && fs.existsSync(path.resolve(packagePath, 'subsystem.json')) && fs.existsSync(path.resolve(packagePath, 'manifest.json')) && fs.existsSync(path.resolve(packagePath, 'logic.js'));
    }
  }, {
    key: "downloadPackage",
    value: function () {
      var _downloadPackage = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref) {
        var productionLineId, productionVersion, _yield$this$getFileUr, fileData, currentFileData, filePath, promiseArr, key;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                productionLineId = _ref.productionLineId, productionVersion = _ref.productionVersion;

                if (!fs.existsSync(this.packageFolderPath)) {
                  fs.mkdirSync(this.packageFolderPath);
                }

                if (this.isCached(productionLineId, productionVersion)) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 5;
                return this.getFileUrl({
                  productionLineId: productionLineId,
                  version: encodeURI(productionVersion)
                });

              case 5:
                _yield$this$getFileUr = _context2.sent;
                fileData = _yield$this$getFileUr.data;
                currentFileData = fileData.find(function (item) {
                  return item.productionLineId === productionLineId && item.productionVersion === productionVersion;
                });
                filePath = mkMoreDir(this.packageFolderPath, [productionLineId, productionVersion]);
                promiseArr = [];

                for (key in currentFileData.file) {
                  promiseArr.push(this.download(currentFileData.file[key], path.resolve(filePath, fileMap.get(key))));
                }

                return _context2.abrupt("return", Promise.all(promiseArr));

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function downloadPackage(_x2) {
        return _downloadPackage.apply(this, arguments);
      }

      return downloadPackage;
    }()
  }]);

  return ProductLine;
}(ApiHandler);

module.exports = ProductLine;