"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var axios = require('./axios');

var baseURL = require('./baseUrl');

var fs = require('fs'); //  查询现网环境的api


var ApiHandler = /*#__PURE__*/function () {
  function ApiHandler() {
    _classCallCheck(this, ApiHandler);
  }

  _createClass(ApiHandler, [{
    key: "getProductLine",
    value: function getProductLine() {
      return axios.get("".concat(baseURL(), "/hpm/registry/api/productline"));
    }
  }, {
    key: "getAllPackagesDependency",
    value: function getAllPackagesDependency() {
      return axios.post("".concat(baseURL(), "/hpm/registry/api/bundles/depth/dependencies"));
    }
  }, {
    key: "getPackage",
    value: function getPackage(params) {
      return axios.get("".concat(baseURL(), "/hpm/registry/api/bundles"), {
        params: params
      });
    }
  }, {
    key: "getFilterData",
    value: function getFilterData() {
      return axios.get("".concat(baseURL(), "/hpm/dist/api/business/classification"));
    }
  }, {
    key: "getAllLicense",
    value: function getAllLicense(body) {
      return axios.post("".concat(baseURL(), "/hpm/registry/api/bundles/depth/open-source"), body, {
        headers: {
          'Content-Type': 'application/json'
        }
      });
    }
  }, {
    key: "getFileUrl",
    value: function getFileUrl(_ref) {
      var productionLineId = _ref.productionLineId,
          version = _ref.version;
      return axios.get("".concat(baseURL(), "/hpm/registry/api/productline/").concat(productionLineId, "?version=").concat(version));
    }
  }, {
    key: "getBundleDetail",
    value: function getBundleDetail(params) {
      return axios.get("".concat(baseURL(), "/hpm/registry/api/bundles/detail/").concat(params));
    }
  }, {
    key: "download",
    value: function () {
      var _download = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url, savePath) {
        var response, writeStream;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return axios({
                  method: 'GET',
                  url: url,
                  responseType: 'stream'
                });

              case 2:
                response = _context.sent;
                writeStream = fs.createWriteStream(savePath);
                response.pipe(writeStream);
                return _context.abrupt("return", new Promise(function (resolve, reject) {
                  writeStream.on('close', function () {
                    resolve(savePath);
                  });
                  writeStream.on('error', reject);
                }));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function download(_x, _x2) {
        return _download.apply(this, arguments);
      }

      return download;
    }() // testUrl() {
    //   return axios.get("https://lfcontentcenterdev.hwcloudtest.cn/pub_1/DevEcoSpace_1_900_9/83/v3/odYMmzJyTIOAGVaDEmMZGw/XppW7hQ2RsmoOQjLKClLkg.json")
    // }

  }]);

  return ApiHandler;
}();

module.exports = ApiHandler;